#pragma once

#include <vector>
#include <utility>

namespace kp {

struct XY
{
	float x, y;
};

struct PathMetadata
{
	std::vector<XY> concave_points;
	std::vector<std::pair<XY, XY>> linked_concave_points;
	std::vector<std::pair<XY, XY>> normal_lines;
	std::vector<XY> start_lines;
	std::vector<XY> end_lines;
};

using Polygon = std::vector<XY>;
using Path = std::vector<XY>;

bool FindPath(XY start, XY end, const Polygon& polygon, Path& path_out, PathMetadata* metadata = nullptr);

} // namespace kp
